from .download import downloading

downloading()
from .download_install_wheels import install_wheels

install_wheels()

from . import translate
import importlib
from . import previews, Preferences, Core, Utils, About
from .Preferences.CheckForUpdates import check_for_updates
from .Utils.LibrariesUtils import get_categories, get_subcategories, get_items_previews

# import os
# import toml

from .t3dn_bip import ops

modules = [previews, Preferences, Core, About]

for module in modules:
    importlib.reload(module)

importlib.reload(Utils)

# bl_info = {
#     "name": "Flow",
#     "author": "polyspaace",
#     "version": (4, 2, 0), ### temp for tests
#     "blender": (4, 2, 0),
#     "location": "Flow & Flow Creator tab in the sidebar of the 3D View window",
#     "description": "The ultimate asset manager for Blender",
#     "category": "3D View",
#     "wiki_url": "https://3d.polyspaace.com/products/flow/docs/",
# }


# data_path = os.path.join(os.path.dirname(__file__), 'blender_manifest.toml')
# data = toml.load(data_path)
version = "4.3.0"


def register():

    for module in modules:
        module.register()

    Preferences.UpdatePanelNames.update_flow_panel(None, None)
    Preferences.UpdatePanelNames.update_flow_creator_panel(None, None)

    check_for_updates(version)

    get_categories.cache_clear()
    get_subcategories.cache_clear()
    get_items_previews.cache_clear()
    translate.register()


def unregister():
    for module in reversed(modules):
        module.unregister()
    translate.unregister()


if __name__ == "__main__":
    register()
